		      Tangentbord ABC99
		      =================



2.0 Kodning och kompatibilitet med 800-datorerna

Eftersom ABC99 har en hel del tangenter som inte fanns p} de
{ldre tangentborden har det {ven tillkommit en m{ngd nya koder.
I appendix A finns ett kodschema |ver tangentbordet. F|r
samtliga tangenter {r de m|jliga koder som kan genereras angivna
enligt f|ljande principer.



2.1 Kodning

2.1.1 UP/DOWN kodning

Koderna vinkelr{tt mot tangentbordets framsida anger de UP/DOWN
koder som genereras d} tangentbordet {r i denna speciella mod.
I denna mod fungerar inte auto-repeat och CAPS LOCK. Koderna
anger vad som skickas till datorn d} tangenten trycks ner. N{r
den sl{pps upp igen skickas samma kod med 128 adderat.

Observera att {ven SHIFT, CTRL och CAPS LOCK skickar koder i
denna mod.


2.1.2 Normal kodning

I normalmod skickar varje tangent fyra m|jliga koder beroende
p} SHIFT och CTRL tangenternas l{ge. 

F|r de tangenter som {r angivna p} schemat med bara en kod
spelar det ingen roll i vilket l{ge SHIFT och CTRL {r, samma
kod genereras alltid.

F|r de som har tv} koder angivna spelar det ingen roll i vilket
l{ge CTRL {r. Den nedersta siffran {r utan SHIFT, den |vre med
SHIFT.

F|r de med fyra olika koder {r den nedersta utan vare sig SHIFT
eller CTRL, d{r ovan med bara SHIFT, d{r ovan med bara CTRL och |verst
med b}de SHIFT och CTRL.


2.2 Nya tangenterna och kompatibilitet

Observera att de nya tangenterna inte automatiskt har n}gon
funktion i 800-seriens maskiner. F|r att t.ex.
mark|rplaceraren verkligen ska flytta mark|ren kr{vs att man
anpassar sin programvara till att avkoda de nya kommandona.
Samma anpassning g{ller f|r STOP, PRINT m.fl.

De gamla h|ger- och v{nsterpiltangenterna ers{tts av TAB
respektive BS (BackSpace).




3.0 Musavkodarens interna struktur

Internt har avkodaren 5 register f|r respektive koordinat, x och
y. De {r alla 12 bitar l}nga dvs. deras inneh}ll kan vara
mellan 0 och FFF (HEX).


F|ljande register finns internt:

  Register:	  Initialv{rde (HEX):
  x-pos			000
  y-pos			000
  x-min			000
  x-max			FFF
  y-min			000
  y-max			FFF
  x-skala		001
  y-skala		001
  x-inkrement		001
  y-inkrement		001


3.1 Registerf|rklaring och funktion

Nedan f|ljer en kort beskrivning av vad som lagras i
respektive register. 

  Pos: 		Anger den aktuella positionen f|r
  		musen.

  Min:		Anger det undre gr{nsv{rdet f|r
  		positionsregistret.
  
  Max:  	Anger det |vre gr{nsv{rdet f|r 
  		positionsregistret.
  
  Skala:	Anger hur l}ng relativ str{cka musen m}ste
		r|ras f|r att positionsregistret ska r{knas
		upp. Ju h|gre v{rde desto st|rre r|relse kr{vs.
		
  Inkrement:	Anger hur mycket som l{ggs till p}
		positionsregistrets v{rde d} det ska
		uppdateras. Ett v{rde skiljt fr}n 1 ger s{mre
		uppl|sning men snabbare uppr{kning av
		positionen.
		

Vid kontinuerlig r|relse i samma riktning fungerar det hela s}
att efter en viss str{cka, som best{ms av skalfaktorsregistret,
s} uppdateras positionsregistret med inneh}llet i
inkrementregistret. Om denna nya position skulle ligga utanf|r
det till}tna intervallet, best{mt av gr{nsregistren, s}
justeras det till att ligga p} respektive gr{ns ist{llet.


3.2 \verf|ring av registerinneh}ll

N{r ett registers inneh}ll ska skickas i n}gon riktning
till/fr}n datorn s} delas det f|rst in i tv} bytes p} sex bitar
vardera. Till dessa b}da bytes adderas d{refter 32 (ASCII) som
offset.  Varje byte kommer d} att ha ett v{rde mellan 32 (ASCII)
och 95 (ASCII). I detta skick s{nds sedan datan |ver
kommunikationskanalen. Detta g|rs f|r att all data som g}r
mellan datorn och tangentbordet ska best} av skrivbara ASCII
tecken.

Knappstatus behandlas p} samma s{tt som register vid |verf|ring.





4.0 Kommandon

Det finns ett antal kommandon som kan skickas till
tangentbordet via tangentbordsporten i datorn. De styr t.ex.
lysdioderna, ljudet och musen. Nedan f|ljer en f|rteckning
|ver dem.

Kod (ASCII)	Funktion
================================================================
    6		S{tter bordet i ASCII-mod (Normalt)
  134		S{tter bordet i UP/DOWN-mod
    7		Ljuder summern i bordet (BELL-tecknet)
    8		Ger normal funktion hos CAPS LOCK tangenten
  136		L}ser CAPS LOCK i p}satt l{ge
   24		Bordet skickar en identifikationskod som svar
    9		St{nger av lysdioden INS
  137		S{tter p} lysdioden INS
   10		St{nger av lysdioden ALT
  138		S{tter p} lysdioden ALT

    1		Summerfunktionen (BELL-tecknet) AV
  129		Summerfunktionen (BELL-tecknet) P]
    2		Kort "klick"-ljud AV
  130		Kort "klick"-ljud P]
    4		L}ngt "klick"-ljud AV
  132		L}ngt "klick"-ljud P]
    5		Auto-repeat AV
  133		Auto-repeat P]

    0		lysdiod 1 P]
  128		lysdiod 1 AV
   16		lysdiod 2 P]
  144		lysdiod 2 AV
   32		lysdiod 3 P]
  160		lysdiod 3 AV
   48		lysdiod 4 P]
  176		lysdiod 4 AV
   64		lysdiod 5 P]
  192		lysdiod 5 AV
   80		lysdiod 6 P]
  208		lysdiod 6 AV
   96		lysdiod 7 P]
  224		lysdiod 7 AV
  112		lysdiod 8 P]
  240		lysdiod 8 AV

   **** Se detaljerad beskrivning p} f|ljande kommandon ****

   57		Skriv data till musens positionsregister
   58		Skriv data till musens skalfaktorsregister
   59		Skriv data till musens gr{nsregister
   60		L{s positionsdata fr}n musen
   62		S{tt p} automatisk positionss{ndning
   63		St{ng av automatisk positionss{ndning

Vid sp{nningsp}slag och reset s{tts summern p}, kort
"klick"-ljud p}, auto-repeat p} och CAPS LOCK normal.



4.1 Identifikationskod

Som svar p} beg{ran om identifikation av tangentbordet svarar
det enligt f|ljande.

  Bin{rkod:
  0001 1011	ESC
  0010 XXXX  	Landsvariant (Appendix B)
  001X XXXX	Tangentbordstyp och status (Appendix B)
  0010 XXXX	LED grupp 5-8 (1=p})
  0010 XXXX	LED grupp 1-4 (1=p})
  0010 0XXX	INS, ALT, CAPS LOCK (1=p})
  0010 0000	Reserv
  
  (X=aktiv bit, se resp. appendix f|r betydelse)


4.2 Kommandon till musen

Musavkodarens interna register kan st{llas med hj{lp av tre
kommandon. Deras syntax {r enligt f|ljande. 

H|g byte inneb{r multiplar av 64 (allts} ej 256 som vanligt!).
L}g byte inneb{r tal upp t.o.m. 63. 

Till b}de h|g och l}g byte l{ggs en offset p} 32 till s} att de
m|jliga v{rden respektive byte kan anta ligger i intervallet 32
till 95. (Detta g|rs enbart f|r |verf|ringens skull och
p}verkar inte resultatet av kommandot).

Vill man t.ex. skicka 560 s} delas detta tal upp i:
  H|g byte:  8+32=40	(560/64 -> 8 heltalsdel)
  L}g byte: 48+32=80	(560/64 -> 48 restdel)

  Positionsregister:	57
  			x-pos h|g byte
			x-pos l}g byte
			y-pos h|g byte
			y-pos l}g byte

  Skalfaktorsregister:	58
  			x-skala h|g byte
			x-skala l}g byte
			y-skala h|g byte
			y-skala l}g byte
			x-inkrement h|g byte
			x-inkrement l}g byte
			y-inkrement h|g byte
			y-inkrement l}g byte

  Gr{nsregister:	59
  			x-min h|g byte
			x-min l}g byte
			x-max h|g byte
			x-max l}g byte
			y-min h|g byte
			y-min l}g byte
			y-max h|g byte
			y-max l}g byte

F|r att fr}n BASIC (endast 802/806) s{tta t.ex. gr{nsregistret
s} skriver man:

10 ! S{tt x-min=0, y-min=50, x-max=256, y-max=200
20 OUT 34,59	! Gr{nsregister
20 OUT 34,32	! x-minimum, h|g byte =  0(med 32 adderat)
30 OUT 34,32	! x-minimum, l}g byte =  0(med 32 adderat)
40 OUT 34,36	! x-maximum, h|g byte =  4(med 32 adderat)
50 OUT 34,32	! x-maximum, l}g byte =  0(med 32 adderat)
60 OUT 34,32	! y-minimum, h|g byte =  0(med 32 adderat)
70 OUT 34,82	! y-minimum, l}g byte = 50(med 32 adderat)
80 OUT 34,35	! y-maximum, h|g byte =  3(med 32 adderat)
90 OUT 34,40	! y-maximum, l}g byte =  8(med 32 adderat)

Se avsnitt 3.2 f|r information om registrens interna utseende
samt kodningsf|rfarande.



4.3 Positionsavl{sning av musen

Det finns tv} s{tt att l{sa av musens position. Antingen kan
det g|ras vid kommando eller s} kan avkodaren f}s att
automatiskt s{nda en koordinatsekvens s} fort musen r|rts en
str{cka. (Se 3.2 f|r kodningsf|rfarande)

H|g byte inneb{r multiplar av 64 (allts} ej 256 som vanligt!).
L}g byte inneb{r tal upp t.o.m. 63. 

Till b}de h|g och l}g byte l{ggs en offset p} 32 till s} att de
m|jliga v{rden respektive byte kan anta ligger i intervallet 32
till 95. (Detta g|rs enbart f|r |verf|ringens skull och
p}verkar inte resultatet av kommandot).

Om tangentbordet ska skicka t.ex. 717 till datorn s} blir det
enligt f|ljande format:
  H|g byte: 11+32=43	(717/64 -> 11 heltalsdel)
  L}g byte: 13+32=45	(717/64 -> 13 restdel)

  Manuell avl{sning:	60

  Avkodaren svarar:	144
  			x-pos h|g byte
			x-pos l}g byte
			y-pos h|g byte
			y-pos l}g byte
			knapp status
			

  Automatisk avl{sning:	62

  Avkodaren svarar:	145
			x-pos h|g byte
			x-pos l}g byte
			y-pos h|g byte
			y-pos l}g byte
  och:			146
			knapp status

  Efter denna f|rsta sekvens s{nder d{refter avkodaren position
  eller knappstatus d} n}gon av dessa f|r{ndras. Denna
  automatiska s{ndning slutar d} 63 (ASCII) skickas till
  tangentbordet.

Manuell avl{sning kan g} till enligt f|ljande i BASIC (endast
802/806 maskiner):

10 ! Manuell avl{sning av mus
20 OUT 34,60		! Kommando
30 GET A$ COUNT 6	! L{s in 6 tecken
40 FOR I = 1 TO 6	! Skriver ut de 6 inl{sta v{rdena
50  ; ASCII(MID$(A$,I,1))
60 NEXT I
70 ! Kom ih}g att de utskrivna v{rdena {r f|rsedda med en offset
80 ! p} 32.

Se avsnitt 3.2 f|r information om registrens interna utseende
samt kodningsf|rfarande.





5.0 Tekniska data

 * Str|mf|rs|rjning: +12V, max 800mA
 * N-key rollover
 * TTL-positiv logik
 * 8-bits seriell kommunikation, full duplex
 * \verf|ringshastighet 8000 Baud
 * En stopp bit vid mottagning, tv} vid s{ndning
 * Baudrate klocka till datorn, 16 X Baudrate
 * Watchdog krets

Kodprom (2716) kan bytas f|r att erh}lla t.ex. olika
landsvarianter. Byte sker i s} fall av prom p} position Z3
(l{ngst bort fr}n muskontakten).

Kontakt till datorn {r en 7-polig DIN hane med f|ljande
signalutseende:

  1  - TxD
  2  - Signaljord
  3  - RxD
  4  - TRxC (Baudrate klocka)
  5  - DCD
  6  - +12V
  7  - RST
  
Till musen anv{nds en 15-polig DSUB hona med f|ljande
signalutseende:

  1  -  5V/50mA
  2  -  XA
  3  -  XB
  4  -  YA
  5  -  YB
  6  -  V{nster knapp
  7  -  Mitten knapp
  8  -  H|ger knapp
9-13 -  NC
  14 -  Indikator, aktiv l}g d} mus ansluten
  15 -  Signaljord






APPENDIX A



	      Tangentbordskodning och numrering






APPENDIX B



Identifikationskod

 Byte 2	   Landsvariant
=======================================
   33		S
   34		N
   35		DK
   36		USA
   37		GB
   38		ES
   39		FR
   40		D
   41		IS



 Byte 3		  Tangentbordstyp
=======================================
---- -001	   ABC55
---- -010	   ABC77
---- -011	   ABC99


---- 1---	   UP/DOWN mod
---- 0---	   Normal mod


---1 ----	   Mus ansluten
---0 ----	   Mus ej ansluten


(- = ej v{sentlig bit)

