Testprogram f|r ABC1600, anvisning.

Detta testprogram {r avsett att k|ras p} ABC1600 utan att
beh|va g|ra n}gra som helst h}rdvarum{ssiga ingrepp. Det
utf|r en verifikation av samtliga funktionsblock i
maskinen, inklusive winchester- och floppyenhet samt
ansluten skrivare. 

F|rutsatt en fungerande skrivarkanal kan programmet
registrera testresultat kontinuerligt p} skrivaren.
Observera dock att en del maskinfel kan orsaka att datorn
'kraschar', d{rigenom avbrytande ev. skrivarregistrering
samt programexekveringen. I s}dana fall kan det vara
n|dv{ndigt med en omstart av testprogrammet om det inte {r
klart under vilken test 'kraschen' skedde.

M}nga fel kan naturligtvis ge en rad f|ljdfel vilket inneb{r
att det inte alltid {r s} l{tt att utifr}n testprogrammets
resultat avg|ra vad som exakt {r felet. F|r att fastst{lla
detta h{nvisas ist{llet till det mera ing}ende h}rdvarutestet
som finns f|r ABC1600.

Programmet ska d{rf|r snarare ses som ett medel att
verifiera en dators funktion {n ett verktyg f|r att ta reda
p} vad som {r fel.



Beskrivning av testerna p} funktionsblocken:

Minnestest:
Detta test utf|r en kontroll av datorns minne i tre
etapper. Den f|rsta {r en adresstest. H{r testas att
adresseringen till minnet fungerar korrekt, dvs. att en
viss minnescell finns p} r{tt plats i minnesrymden och
dessutom bara f|rekommer en g}ng d{r.

Steg tv} {r bittest som utf|rs f|rst med vandrande 1:a och
d{refter med vandrande 0:a. Testet g}r till s} att f|rst
fylls hela minnet med ett visst bitm|nster. D{refter l{ses
samtliga celler f|r att verifiera att deras
inneh}ll st{mmer med det som skrevs i dem. Proceduren
upprepas sedan f|r samtliga bitpositioner.

Etapp tre {r en bytetest som i princip testar minnet genom
att snabbt omv{xlande skriva och l{sa till/fr}n minnet.



Kretstest:
Kretstestet utg|r egentligen en sammanslagning av flera tester
under ett gemensamt namn. Var och en av dessa deltester
redog|rs f|r separat nedan:

  CIO:
  Denna krets sitter som n}got av spindeln i n{tet vad g{ller
  klockpulsgenerering och externa avbrott. M}nga andra kretsar
  {r direkt eller indirekt beroende av CIO-kretsens funktion.
  D{rf|r blir den ocks} relativt v{ltested i testprogrammet.

  Testet b|rjar med ett l{s/skriv test till dess interna
  register.  

  D{refter f|ljer testning av de tre interna klockorna genom
  tidtagning.

  Till sist s{tts kretsen upp f|r att generera r{tt klockpulser
  f|r skrivarkanalen.


  Kalender/Klocka:
  Denna krets {r kopplad till en parallell port i CIO-kretsen.
  Kommunikationen sker seriellt |ver en bit i porten. 
  
  Funktionsverifiering sker genom att spara klockan, skriva ut
  ett nytt klockslag, se att det blev korrekt skrivet och att
  det sedan uppdateras av klockan. Slutligen }terst{lls korrekt
  klockslag.
  
  
  NVRAM:
  Denna krets {r ocks} kopplad till en bit i en parallell port
  i CIO-kretsen.
  
  Testet b|rjar med att en verifikation av inneh}llet i
  NVRAM-kretsen g|rs mot v{ntade v{rden.
  
  Efter detta s} provas l{sning/skrivning av dess interna
  register.
  
  
  DMA:
  De tre DMA-kretsarna testas i tur och ordning genom att
  flytta ett minnesblock fr}n en position till en annan i
  minnesrymden. Det flyttade blocket j{mf|rs sedan med
  orginalet f|r att fastst{lla ev. avvikelser.
  
  DMA-kretsarna testas ytterligare genom Winchester- och
  Floppytestprogrammen.



Skrivarkanalstest:
Datorn kommunicerar med skrivaren genom DART-kretsen, som {ven
sk|ter tangentbordskommunikationen. En f|ruts{ttning f|r
korrekt |verf|ringshastighet p} skrivarkanalen {r dock att
CIO-kretsens klockgenerering fungerar.

Testet b|rjar med att prova DART-kretsens interna register i
ett skriv/l{s test.

D{refter g|rs en kontroll av att dess signaler till skrivaren
fungerar samt en verifiering av att en skrivare finns ansluten.

Slutligen g|rs en provutskrift p} skrivaren. Samma utskrift
kommer p} sk{rmen s} att resultaten l{tt kan j{mf|ras.



Kommunikationstest:
Detta test provar SCC-kretsens funktion. SCC-kretsen sk|ter all
seriell kommunikation med omv{rlden |ver de tv} TTY-ing}ngarna.
Endast asynkron mod testas h{r.

Testet g}r till s} att f|rst initieras kanalerna A och B s} att
de b{gge {r aktiva. Deras signalhantering provas s} att kretsen
svarar korrekt.

D{refter kan ett kommunikationstest utf|ras mellan kanalerna
f|r att se om s{ndning/mottagning fungerar mellan dem.
F|ruts{ttningen f|r detta test {r dock att man kopplat en
extern kabel mellan TTY-utg}ngarna.



Terminaltest:
Detta test {r en forts{ttning p} kommunikationstestet ovan. H{r
provas att seriella kommunikationen fungerar {ven med en extern
terminal (m}ste anslutas). D{rigenom kontrolleras
|verf|ringshastigheten s} att den verkligen ligger p} 9600baud.

Testet genomf|rs med ett utskriftsprov p} terminalen f|ljt av
inmatningsprov fr}n terminalen.



Winchestertest:
Detta test utnyttjar m}nga av de sj{lvtestfaciliteter som
finns i XEBEC-kontrollern. Dessutom g|rs upprepade
positionerings/l{s-test av winchestern.

F|rst f}r XEBEC-kontrollern genomg} sitt interna RAM-test och
kretstest, liksom dess skivtest som verifierar skivans
formattering. 

D{refter utf|rs en serie provl{sningar och positioneringar p}
winchestern. Den sista serien anv{nder DMA f|r |verf|ringen av
data.



Floppytest:
F|r att detta test ska kunna genomf|ras m}ste en formatterad
skiva s{ttas i skivenheten. Testet provar
floppy-controllerkretsen samt verifierar l{sning/skrivning av
skivan.

Testet b|rjar med en formatteringskontroll. H{r kontrolleras
positionering av skriv/l{shuvudet samt att skivan {r korrekt
formatterad.

D{refter b|rjar en serie skriv/l{ssekvenser, samtliga under DMA-
kontroll. 



Sk{rmtest:
Detta test provar movern och bildminnet. Det {r {ven anv{ndbart
f|r att st{lla in monitorn. Observera dock att det {r upp till
anv{ndaren att avg|ra testets resultat.



Tangentbordstest: 
Detta test g}r igenom samtliga funktioner hos ABC99
tangentbordet. Det kr{vs en hel del anv{ndarinteraktion f|r att
genomf|ra provet.  F|r ytterligare information om dess funktion
h{nvisas till bruksanvisningen f|r tangentbordet.



Mustest:
Detta test verifierar musens funktion. Det {r helt beroende av
anv{ndarinteraktion f|r att g|ra detta.  [ven h{r h{nvisas till
bruksanvisningen f|r ABC99 f|r ytterligare information.
